# OGRStyleMgr Class Reference

`#include <ogr_featurestyle.h>`

List of all members.

## Public Member Functions
| OGRStyleMgr (OGRStyleTable *poDataSetStyleTable=NULL)
| Constructor.
| ~OGRStyleMgr ()
| Destructor.
GBool | SetFeatureStyleString (OGRFeature *, const char *pszStyleString=NULL, GBool bNoMatching=FALSE)
| Set a style in a feature.
const char * | InitFromFeature (OGRFeature *)
| Initialize style manager from the style string of a feature.
GBool | InitStyleString (const char *pszStyleString=NULL)
| Initialize style manager from the style string.
const char * | GetStyleName (const char *pszStyleString=NULL)
| Get the name of a style from the style table.
const char * | GetStyleByName (const char *pszStyleName)
| find a style in the current style table.
GBool | AddStyle (const char *pszStyleName, const char *pszStyleString=NULL)
| Add a style to the current style table.
const char * | GetStyleString (OGRFeature *=NULL)
| Get the style string from the style manager.
GBool | AddPart (OGRStyleTool *)
| Add a part (style tool) to the current style.
GBool | AddPart (const char *)
| Add a part (style string) to the current style.
int | GetPartCount (const char *pszStyleString=NULL)
| Get the number of parts in a style.
OGRStyleTool * | GetPart (int hPartId, const char *pszStyleString=NULL)
| Fetch a part (style tool) from the current style.

## Detailed Description

This class represents a style manager

## Constructor & Destructor Documentation

OGRStyleMgr::OGRStyleMgr | ( | OGRStyleTable * | poDataSetStyleTable = `NULL` | ) |

Constructor.

This method is the same as the C function OGR_SM_Create()

Parameters:

  | poDataSetStyleTable | (currently unused, reserved for future use), pointer to OGRStyleTable. Pass NULL for now.

Referenced by OGR_SM_Create().

OGRStyleMgr::~OGRStyleMgr | ( |  | ) |

Destructor.

This method is the same as the C function OGR_SM_Destroy()

## Member Function Documentation

GBool OGRStyleMgr::SetFeatureStyleString | ( | OGRFeature * | poFeature,
|  | const char * | pszStyleString = `NULL`,
|  | GBool | bNoMatching = `FALSE` |
| ) |  |  |

Set a style in a feature.

Parameters:

  | poFeature | the feature object to store the style in
  | pszStyleString | the style to store
  | bNoMatching | TRUE to lookup the style in the style table and add the name to the feature

Returns:
  TRUE on success, FALSE on error.

References GetStyleName(), and OGRFeature::SetStyleString().

const char * OGRStyleMgr::InitFromFeature | ( | OGRFeature * | poFeature | ) |

Initialize style manager from the style string of a feature.

This method is the same as the C function OGR_SM_InitFromFeature().

Parameters:

  | poFeature | feature object from which to read the style.

Returns:
  a reference to the style string read from the feature, or NULL in case of error..

References OGRFeature::GetStyleString(), and InitStyleString().

Referenced by GetStyleString().

GBool OGRStyleMgr::InitStyleString | ( | const char * | pszStyleString = `NULL` | ) |

Initialize style manager from the style string.

This method is the same as the C function OGR_SM_InitStyleString().

Parameters:

  | pszStyleString | the style string to use (can be NULL).

Returns:
  TRUE on success, FALSE on errors.

References GetStyleByName().

Referenced by InitFromFeature().

const char * OGRStyleMgr::GetStyleName | ( | const char * | pszStyleString = `NULL` | ) |

Get the name of a style from the style table.

Parameters:

  | pszStyleString | the style to search for, or NULL to use the style currently stored in the manager.

Returns:
  The name if found, or NULL on error.

References OGRStyleTable::GetStyleName().

Referenced by SetFeatureStyleString().

const char * OGRStyleMgr::GetStyleByName | ( | const char * | pszStyleName | ) |

find a style in the current style table.

Parameters:

  | pszStyleName | the name of the style to add.

Returns:
  the style string matching the name or NULL if not found or error.

References OGRStyleTable::Find().

Referenced by InitStyleString().

GBool OGRStyleMgr::AddStyle | ( | const char * | pszStyleName,
|  | const char * | pszStyleString = `NULL` |
| ) |  |  |

Add a style to the current style table.

This method is the same as the C function OGR_SM_AddStyle().

Parameters:

  | pszStyleName | the name of the style to add.
  | pszStyleString | the style string to use, or NULL to use the style stored in the manager.

Returns:
  TRUE on success, FALSE on errors.

References OGRStyleTable::AddStyle().

const char * OGRStyleMgr::GetStyleString | ( | OGRFeature * | poFeature = `NULL` | ) |

Get the style string from the style manager.

Parameters:

  | poFeature | feature object from which to read the style or NULL to get the style string stored in the manager.

Returns:
  the style string stored in the feature or the style string stored in the style manager if poFeature is NULL

NOTE: this method will call OGRStyleMgr::InitFromFeature() if poFeature is not NULL and replace the style string stored in the style manager

References InitFromFeature().

GBool OGRStyleMgr::AddPart | ( | OGRStyleTool * | poStyleTool | ) |

Add a part (style tool) to the current style.

This method is the same as the C function OGR_SM_AddPart().

Parameters:

  | poStyleTool | the style tool defining the part to add.

Returns:
  TRUE on success, FALSE on errors.

References OGRStyleTool::GetStyleString().

GBool OGRStyleMgr::AddPart | ( | const char * | pszPart | ) |

Add a part (style string) to the current style.

Parameters:

  | pszPart | the style string defining the part to add.

Returns:
  TRUE on success, FALSE on errors.

int OGRStyleMgr::GetPartCount | ( | const char * | pszStyleString = `NULL` | ) |

Get the number of parts in a style.

This method is the same as the C function OGR_SM_GetPartCount().

Parameters:

  | pszStyleString | (optional) the style string on which to operate. If NULL then the current style string stored in the style manager is used.

Returns:
  the number of parts (style tools) in the style.

OGRStyleTool * OGRStyleMgr::GetPart | ( | int | nPartId,
|  | const char * | pszStyleString = `NULL` |
| ) |  |  |

Fetch a part (style tool) from the current style.

This method is the same as the C function OGR_SM_GetPart().

This method instanciates a new object that should be freed with OGR_ST_Destroy().

Parameters:

  | nPartId | the part number (0-based index).
  | pszStyleString | (optional) the style string on which to operate. If NULL then the current style string stored in the style manager is used.

Returns:
  OGRStyleTool of the requested part (style tools) or NULL on error.

References OGRStyleTool::SetStyleString().

The documentation for this class was generated from the following files:

- ogr_featurestyle.h
- ogrfeaturestyle.cpp

Generated for GDAL by 1.5.6.